#ifndef Assembler_hpp
#define Assembler_hpp

#include "Parser.hpp"
#include "Loader.hpp"

namespace SoftWire
{
	class Assembler
	{
	public:
		Assembler(const char *fileName);

		~Assembler();

		const void *callable();

	private:
		Parser parser;
		Loader loader;

		int lineNumber;
		bool error;

		void assembleFile(const char *sourceFile);
		void assembleLine(const char *sourceLine);

		static void printLine(const char *string);
	};
}

#endif   // Assembler_hpp