#ifndef InstructionSet_hpp
#define InstructionSet_hpp

#include "Instruction.hpp"

namespace SoftWire
{
	class InstructionSet
	{
	public:
		InstructionSet();

		~InstructionSet();

		Instruction *query(const char *mnemonic) const;

	private:
		struct Entry
		{
			const char *mnemonic;

			Instruction *instruction;
		};

		Entry *instructionMap;

		static int compareSyntax(const void *syntax1, const void *syntax2);
		static int compareEntry(const void *mnemonic, const void *entry);

		static Instruction::Syntax instructionSet[];

		static int numInstructions();
		static int numMnemonics();
	};
}

#endif   // InstructionSet_hpp